﻿using System.Data;
using System.Collections.Generic;
using System.Linq;

using Dapper;

namespace TestProject
{
    /// <summary>
    /// 상품
    /// </summary>
    public class Product
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 제품 ID - ProductID

        /// <summary>
        /// 제품 ID
        /// </summary>
        public int ProductID { get; set; }

        #endregion
        #region 제품명 - ProductName

        /// <summary>
        /// 제품명
        /// </summary>
        public string ProductName { get; set; }

        #endregion
        #region 단가 - UnitPrice

        /// <summary>
        /// 단가
        /// </summary>
        public decimal UnitPrice { get; set ; }

        #endregion
        #region 단종 여부 - Discontinued

        /// <summary>
        /// 단종 여부
        /// </summary>
        public bool Discontinued { get; set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 제품 리스트 구하기 - GetProductList(connection)

        /// <summary>
        /// 제품 리스트 구하기
        /// </summary>
        /// <param name="connection">연결</param>
        /// <returns>제품 리스트</returns>
        public static List<Product> GetProductList(IDbConnection connection)
        {
            var resultList = connection.Query<Product>("SELECT * FROM Products ORDER BY ProductName ASC").ToList();

            return resultList;
        }

        #endregion
    }
}